%global     alphatag        20120325
%global     svn_revision    svn630
%global     debug_package   %{nil}

# The source for this package was pulled from upstream's subversion (svn).
# Use the following commands to generate the tarball:
# svn export -r 630 http://svn.dsource.org/projects/derelict/branches/Derelict2 derelict-20120325svn630
# tar -cJvf derelict-20120325svn630.tar.xz derelict-20120325svn630

Name:           derelict
Version:        2
Release:        22.%{alphatag}%{svn_revision}%{?dist}
Summary:        Collection of D bindings to C shared libraries

License:        Boost 
URL:            http://www.dsource.org/projects/
Source0:        %{name}-%{alphatag}%{svn_revision}.tar.xz
BuildRequires:  ldc, ldc-phobos-devel, ldc-druntime-devel


%description
derelict supports some useful features for project development, including:
- Cross-Platform Consistency
derelict loads shared libraries manually at runtime and throws an exception
when the library, or any symbol in the library, fails to load. This gives you
complete control over how to handle the case of a missing shared library. You
can fall back to a different code path, give your users a helpful error message
or take any action you want. Regardless, you have consistent behavior across
multiple platforms. 
- Selective Symbol Loading - This feature allows you to override exceptions
thrown by derelict when a shared library symbol fails to load. It is a goal of
the project that each derelict package be updated from time-to-time to load the
latest version of each library. Often, new library versions include new
functions. If a user has an older version of the library installed, one that is
missing the new function symbols, derelict will notice and throw an exception.
By making use of Selective Symbol Loading, you can override this behavior and
allow the older library version to load successfully. 

%description -l fr
derelict soutient quelques dispositifs utiles pour le développement de projet
incluant :
- Uniformité du code portable sur plusieurs plates-formes 
Derelict charge les bibliothèques partagées manuellement au temps d'exécution
et
renvoie une exception quand une bibliothèque, ou n'importe quel symbole dans la
bibliothèque, ne charge pas. Ceci vous donne le contrôle complet sur la façon
de traiter le cas où une bibliothèque partagée ne chargerait pas. Vous pouvez
retomber à un chemin différent de code, donner à vos utilisateurs un message
d'erreur utile ou prendre n'importe quelle mesure que vous voulez. Sans avoir
à vous soucier d'un comportement identique à travers de multiples
plates-formes.
- Chargement sélectif de symbole - ce dispositif vous permet de surcharger des
exceptions renvoyées par derelict quand un symbole de bibliothèque partagée ne
charge pas. C'est un but du projet que le paquet derelict soit mis à jour afin
de charger la dernière version de chaque bibliothèque. Souvent, les nouvelles
versions de bibliothèque incluent de nouvelles fonctions. Si un utilisateur a
une version plus ancienne de la bibliothèque installée, ou une à laquelle il
manque les nouveaux symboles d'une fonction, derelict le notera et renverra une
exception. En se servant du chargement sélectif des symboles, vous pouvez
dépasser
ce comportement et permettre à la version la plus ancienne de derelict de se
charger avec succès.

%package        AL-devel
Summary:        Support for developing D application
Provides:       AL-static = %{version}-%{release}
BuildRequires:  openal-soft-devel
Requires:       %{name} =  %{version}-%{release}
Requires:       derelict-Util-devel
Requires:       openal-soft

%description AL-devel
The derelictAL-devel package contains header files for developing D
applications that use derelictAL.

%description AL-devel -l fr
Le paquet derelictAL-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant derelictAL.

%package        allegro-devel
Summary:        Support for developing D application
Provides:       allegro-static = %{version}-%{release}
Requires:       %{name} =  %{version}-%{release}
Requires:       ldc-phobos-devel, ldc-druntime-devel
Requires:       derelict-Util-devel
Requires:       allegro5,              allegro5-devel
Requires:       allegro5-addon-acodec, allegro5-addon-acodec-devel
Requires:       allegro5-addon-audio,  allegro5-addon-audio-devel
Requires:       allegro5-addon-dialog, allegro5-addon-dialog-devel      
Requires:       allegro5-addon-image,  allegro5-addon-image-devel
Requires:       allegro5-addon-physfs, allegro5-addon-physfs-devel
Requires:       allegro5-addon-ttf,    allegro5-addon-ttf-devel

%description allegro-devel
The derelict-allegro-devel package contains header files for developing D
applications that use allegro library for use in computer games and other types
of multimedia programming.

%description allegro-devel -l fr
Le paquet derelict-allegro-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant allegro.

%package        FT-devel
Summary:        Support for developing D application
Provides:     FT-static = %{version}-%{release}
Requires:       %{name} =  %{version}-%{release}
Requires:       ldc-phobos-devel, ldc-druntime-devel
Requires:       derelict-Util-devel

%description FT-devel
The derelict-FT-devel package contains header files for developing D
applications that use derelictFT.

%description FT-devel -l fr
Le paquet derelict-FT-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant derelictFT.


%package        GL-devel
Summary:        Support for developing D application
Provides:       GL-static = %{version}-%{release}
BuildRequires:  mesa-libGL-devel, mesa-libGLU-devel, mesa-libGLw-devel
Requires:       %{name} =  %{version}-%{release}
Requires:       ldc-phobos-devel, ldc-druntime-devel
Requires:       derelict-Util-devel
Requires:       mesa-libGL, mesa-libGLU, mesa-libGLw

%description GL-devel
The derelict-GL-devel package contains header files for developing D
applications that use derelict-GL.

%description GL-devel -l fr
Le paquet derelict-GL-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant derelict-GL.


%package        IL-devel
Summary:        Support for developing D application
Provides:       IL-static = %{version}-%{release}
Requires:       %{name} =  %{version}-%{release}
BuildRequires:  DevIL-ILUT-devel
Requires:       ldc-phobos-devel, ldc-druntime-devel
Requires:       derelict-Util-devel
Requires:       DevIL, DevIL-ILUT

%description IL-devel
The derelictIL-devel package contains header files for developing D
applications that use derelictIL.

%description IL-devel -l fr
Le paquet derelict-IL-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant derelict-IL.


%package        ODE-devel
Summary:        Support for developing D application
Provides:       ODE-static = %{version}-%{release}
Requires:       %{name} =  %{version}-%{release}
Requires:       ldc-phobos-devel, ldc-druntime-devel
Requires:       derelict-Util-devel
Requires:       ode

%description ODE-devel
The derelict-ODE-devel package contains header files for developing D
applications that use derelictODE.

%description ODE-devel -l fr
Le paquet derelic-tODE-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant derelict-ODE.


%package        Ogg-devel
Summary:        Support for developing D application
Provides:       Ogg-static = %{version}-%{release}
Requires:       %{name} =  %{version}-%{release}
Requires:       ldc-phobos-devel, ldc-druntime-devel
Requires:       derelict-Util-devel
Requires:       libvorbis

%description Ogg-devel
The derelict-Ogg-devel package contains header files for developing D
applications that use derelictOgg.

%description Ogg-devel -l fr
Le paquet derelict-Ogg-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant derelict-Ogg.


%package        PA-devel
Summary:        Support for developing D application
Provides:       PA-static = %{version}-%{release}
Requires:       %{name} =  %{version}-%{release}
Requires:       ldc-phobos-devel, ldc-druntime-devel
Requires:       derelict-Util-devel

%description PA-devel
The derelict-PA-devel package contains header files for developing D
applications that use derelictPA.

%description PA-devel -l fr
Le paquet derelict-PA-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant derelict-PA.


%package        SDL-devel
Summary:        Support for developing D application
Provides:       SDL-static = %{version}-%{release}
Requires:       %{name} =  %{version}-%{release}
Requires:       ldc-phobos-devel, ldc-druntime-devel
Requires:       derelict-Util-devel
BuildRequires:  SDL-devel, SDL_image-devel, SDL_mixer-devel, SDL_net-devel
BuildRequires:  SDL_sound-devel, SDL_ttf-devel, SDL_gfx-devel
Requires:       SDL, SDL_image, SDL_mixer, SDL_net
Requires:       SDL_sound, SDL_ttf, SDL_gfx

%description SDL-devel
The derelict-SDL-devel package contains header files for developing D
applications that use derelict-SDL.

%description SDL-devel -l fr
Le paquet derelict-SDL-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant derelict-SDL.


%package        SFML-devel
Summary:        Support for developing D application
Provides:       SFML-static = %{version}-%{release}
Requires:       %{name} =  %{version}-%{release}
Requires:       ldc-phobos-devel, ldc-druntime-devel
Requires:       derelict-Util-devel
Requires:       SFML-devel

%description SFML-devel
The derelict-SFML-devel package contains header files for developing D
applications that use derelictSFML.

%description SFML-devel -l fr
Le paquet derelict-SFML-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant derelict-SFML.


%package        Util-devel
Summary:        Support for developing D application
Provides:       Util-static = %{version}-%{release}
Requires:       %{name} =  %{version}-%{release}
Requires:       ldc-phobos-devel, ldc-druntime-devel

%description Util-devel
The DerelictUtil-devel package contains header files for developing D
applications that use DerelictUtil.

%description Util-devel -l fr
Le paquet Derelict-Util-devel contient les fichiers d'entêtes pour développer
des applications en D utilisant Derelict-Util.


%package geany-tags
Summary:        Support for enable autocompletion in geany
Requires:       %{name} =  %{version}-%{release}
BuildRequires:  geany
Requires:       geany

%description geany-tags
Enable autocompletion for derelict library in geany (IDE)

%description -l fr geany-tags
Active l'autocompletion pour pour la bibliothèque derelict dans geany (IDE)

%prep
%setup -q -n %{name}-%{alphatag}%{svn_revision}
find . -type f | xargs sed -i 's/\\x0a/\n/g'
find .  -type f | xargs sed -i 's/^M$//'

mv inc/ldc_inc.mak inc/ldc2_inc.mak

find . -name "Makefile" | xargs sed -i "s/ldc_build/ldc2_build/g"

# temp geany config directory for allow geany to generate tags
mkdir -p geany_config

%build
# build derelict
make  -f linux.mak DC=ldc2 DFLAGS="%{_d_optflags}"   \
    DerelictAL_ALL                              \
    DerelictAllegro_ALL                         \
    DerelictFT_ALL                              \
    DerelictGL_ALL                              \
    DerelictIL_ALL                              \
    DerelictODE_ALL                             \
    DerelictOgg_ALL                             \
    DerelictPA_ALL                              \
    DerelictSDL_ALL                             \
    DerelictSFML_ALL                            \
    DerelictUtil_ALL
# fix file from bad multi-line comment format and some extra \x0a
find import/%{name} -name "*.di" | xargs sed -i 's/\\x0a/\n/'g
find import/%{name} -name "*.di" | xargs sed -i  '$!N;s|/\*\s*\n\(\s*\)\*\*|/**\n\1*|g'
find import/%{name} -name "*.di" | xargs sed -i  '$!N;s|/\*\s*\n\(\s*\)\*\*|/**\n\1*|g' 
# generate geany tags
geany -c geany_config -g derelict.d.tags $(find import/%{name} -name "*.di")

%install
mkdir -p    %{buildroot}%{_datadir}/geany/tags/
mkdir -p    %{buildroot}%{_d_includedir}/%{name}
mkdir -p    %{buildroot}%{_libdir}
mkdir -p    %{buildroot}%{_docdir}/%{name}-%{version}
# install derelict headers
cp -rp      import/%{name}/* %{buildroot}%{_d_includedir}/%{name}/
# install doc files
mv lib/DUMMY.txt %{buildroot}%{_docdir}/%{name}-%{version}
# install derelict libs
cp -p       lib/*            %{buildroot}%{_libdir}/
# install geany tags
install -m0755 derelict.d.tags %{buildroot}/%{_datadir}/geany/tags/

%files
%doc doc/* 
%{_d_includedir}/%{name}

%files AL-devel
%{_d_includedir}/%{name}/openal
%{_libdir}/libDerelictAL.a

%files allegro-devel
%{_d_includedir}/%{name}/allegro
%{_libdir}/libDerelictAllegro*.a

%files FT-devel
%{_d_includedir}/%{name}/freetype
%{_libdir}/libDerelictFT.a

%files GL-devel
%{_d_includedir}/%{name}/opengl
%{_libdir}/libDerelictGL*.a

%files IL-devel
%{_d_includedir}/%{name}/devil
%{_libdir}/libDerelictIL*.a

%files ODE-devel
%{_d_includedir}/%{name}/ode
%{_libdir}/libDerelictODE.a

%files Ogg-devel
%{_d_includedir}/%{name}/ogg
%{_libdir}/libDerelictOGG.a
%{_libdir}/libDerelictVorbis*.a

%files PA-devel
%{_d_includedir}/%{name}/portaudio
%{_libdir}/libDerelictPA.a

%files SDL-devel
%{_d_includedir}/%{name}/sdl
%{_libdir}/libDerelictSDL*.a

%files SFML-devel
%{_d_includedir}/%{name}/sfml
%{_libdir}/libDerelictSFML*.a

%files Util-devel
%{_d_includedir}/%{name}/util
%{_libdir}/libDerelictUtil.a

%files geany-tags
%{_datadir}/geany/tags/derelict.d.tags

%changelog
* Wed Feb 01 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-22.20111106svn593
- rebuild dmdfe 2.059

* Wed Feb 01 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-21.20111106svn593
- fix broken dependencies

* Thu Jan 19 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-20.20111106svn593
- Fix summary

* Fri Jan 12 2012 Jonathan MERCIER <bioinfornatics at gmail.com> 2-19.20111106svn593
- merge static subpackage with corresponding dvel subpackage for follow Packaging Static Libraries Guidelines

* Sat Jan 7 2012  Jonathan MERCIER <bioinfornatics at gmail.com> 2-18.20111106svn593
- Fix misspellling in description
- put devel dependencies for devel subpackage
- Fix end of line in css file

* Fri Jan 6 2012  Jonathan MERCIER <bioinfornatics at gmail.com> 2-17.20111106svn593
- fix license in spec file (Boost  not GPLv3+)

* Sat Dec 31 2011  Jonathan MERCIER <bioinfornatics at gmail.com> 2-16.20111106svn593
- fix typo in spec file

* Mon Dec 19 2011 Jonathan MERCIER <bioinfornatics at gmail.com> 2-15.20111106svn593
- Remove BuildRoot Tag
- Remove extra target DerelictFT for make they are already DerelictFT_ALL
- Remove DdocToDevhelp
- %%doc owns doc/*
- fix changelog

* Tue Dec 14 2011 Jonathan MERCIER <bioinfornatics at gmail.com> 2-14.20111106svn593
- Remove devhelp package it is useless
- Update to revision 593

* Sun Dec 11 2011 Jonathan MERCIER <bioinfornatics at gmail.com> 2-13.20111031svn591
- fix buildrequires and require
- remove %%defattr and Group section

* Fri Dec 9 2011  Jonathan MERCIER <bioinfornatics at gmail.com> 2-12.20111031svn591
- Add doc for devhelp
- Add tag for geany

* Sat Nov 12 2011  Jonathan MERCIER <bioinfornatics at gmail.com> 2-11.20111031svn591
- Update to revision 591

* Sat Aug 06 2011  Jonathan MERCIER <bioinfornatics at gmail.com> 2-11.20111024svn590
- Update to revision 590

* Sat Aug 06 2011  Jonathan MERCIER <bioinfornatics at gmail.com> 2-10.20110806svn582
- Update to revision 582

* Wed Dec 08 2010  Jonathan MERCIER <bioinfornatics at gmail.com> 2-9.20101207svn521
- Update to revision 521

* Mon Dec 06 2010  Jonathan MERCIER <bioinfornatics at gmail.com> 2-8.20101201svn519
- Update to revision 519

* Wed Sep 15 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-7.20100824svn513
- remove \x0a character by a real newline

* Mon Sep 13 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-6.20100824svn513
- Fix spec add require and build require

* Sun Sep 12 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-5.20100824svn513
- Fix spec

* Thu Aug 26 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-4.20100824svn513
- update to release 513

* Wed Aug 11 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-3.20100801svn499
- remove debuginfo package because it is a static librarie
- Update to new revision 499

* Tue Aug 03 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-2.20100801svn495
- Update to new revision 495

* Sun Aug 01 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-2.20100801svn493
- Update to new revision 493

* Sat Jul 31 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-2.20100407svn490
- use %%{_libdir}

* Sun Jul 04 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-1.20100407svn490
- Initial release
